//+------------------------------------------------------------------+
//|                                                billko_volume.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_plots   4
//--- plot Label1
#property indicator_label1  "New High Bar"
#property indicator_label2  "New Low Bar"
#property indicator_label3  "Outside Bar"
#property indicator_label4  "Inside Bar"

//--- input parameters
extern ENUM_TIMEFRAMES TimeFrame  = PERIOD_CURRENT;       // Time frame
input color    NewHighBar=Blue;
input color    NewLowBar=Red;
input color    OutsideBar=Gray;
input color    InsideBar=White;
//--- indicator buffers
double         NHB[];
double         NLB[];
double         OB[];
double         IB[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,NHB);  SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2,NewHighBar);
   SetIndexBuffer(1,NLB);  SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,2,NewLowBar);
   SetIndexBuffer(2,OB);   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,2,OutsideBar);
   SetIndexBuffer(3,IB);   SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,4,InsideBar);
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame==-99;
            TimeFrame         = MathMax(TimeFrame,_Period);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int counted_bars = prev_calculated;
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit=MathMin(rates_total-counted_bars,rates_total-1);
            if (returnBars) { NHB[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != _Period)
            {
               #define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,_buff,_y)
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  NHB[i] = _mtfCall(0,y);
                  NLB[i] = _mtfCall(1,y);
                  OB [i] = _mtfCall(2,y);
                  IB [i] = _mtfCall(3,y);
               }
               return(0);
            }


   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      OB[i] =EMPTY_VALUE;
      NHB[i]=EMPTY_VALUE;
      NLB[i]=EMPTY_VALUE;
      IB[i] =EMPTY_VALUE;

            
      if(i<Bars-1 && high[i]>high[i+1])
      {
         if(low[i]<low[i+1])
                  OB[i]  = (double)tick_volume[i];
         else     NHB[i] = (double)tick_volume[i];
         continue;
      }
      if(i<Bars-1 && low[i]<low[i+1])
            { NLB[i] = (double)tick_volume[i]; continue; } 
              IB[i]  = (double)tick_volume[i];
   }  
   return(rates_total);
}